<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-35"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/Basic%20Operators%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>Basic Operators &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="BasicOperators.html#">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="BasicOperators.html#">Basic Operators</a><ul>
<li><a class="reference internal" href="BasicOperators.html#ID61">Terminology</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID62">Assignment Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID63">Arithmetic Operators</a><ul>
<li><a class="reference internal" href="BasicOperators.html#ID64">Remainder Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID67">Unary Minus Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID68">Unary Plus Operator</a></li>
</ul>
</li>
<li><a class="reference internal" href="BasicOperators.html#ID69">Compound Assignment Operators</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID70">Comparison Operators</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID71">Ternary Conditional Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID72">Nil-Coalescing Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID73">Range Operators</a><ul>
<li><a class="reference internal" href="BasicOperators.html#ID74">Closed Range Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID75">Half-Open Range Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID562">One-Sided Ranges</a></li>
</ul>
</li>
<li><a class="reference internal" href="BasicOperators.html#ID76">Logical Operators</a><ul>
<li><a class="reference internal" href="BasicOperators.html#ID77">Logical NOT Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID78">Logical AND Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID79">Logical OR Operator</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID80">Combining Logical Operators</a></li>
<li><a class="reference internal" href="BasicOperators.html#ID81">Explicit Parentheses</a></li>
</ul>
</li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="basic-operators">
<h1>Basic Operators<a class="headerlink" href="BasicOperators.html#basic-operators" title="Permalink to this headline"></a></h1>
<p>An <em>operator</em> is a special symbol or phrase that you use to check, change, or combine values. For example, the addition operator (<code class="docutils literal"><span class="pre">+</span></code>) adds two numbers, as in <code class="docutils literal"><span class="pre">let</span> <span class="pre">i</span> <span class="pre">=</span> <span class="pre">1</span> <span class="pre">+</span> <span class="pre">2</span></code>, and the logical AND operator (<code class="docutils literal"><span class="pre">&amp;&amp;</span></code>) combines two Boolean values, as in <code class="docutils literal"><span class="pre">if</span> <span class="pre">enteredDoorCode</span> <span class="pre">&amp;&amp;</span> <span class="pre">passedRetinaScan</span></code>.</p>
<p>Swift supports most standard C operators and improves several capabilities to eliminate common coding errors. The assignment operator (<code class="docutils literal"><span class="pre">=</span></code>) doesn&rsquo;t return a value, to prevent it from being mistakenly used when the equal to operator (<code class="docutils literal"><span class="pre">==</span></code>) is intended. Arithmetic operators (<code class="docutils literal"><span class="pre">+</span></code>, <code class="docutils literal"><span class="pre">-</span></code>, <code class="docutils literal"><span class="pre">*</span></code>, <code class="docutils literal"><span class="pre">/</span></code>, <code class="docutils literal"><span class="pre">%</span></code> and so forth) detect and disallow value overflow, to avoid unexpected results when working with numbers that become larger or smaller than the allowed value range of the type that stores them. You can opt in to value overflow behavior by using Swift&rsquo;s overflow operators, as described in <a class="reference internal" href="AdvancedOperators.html#ID37"><span class="std std-ref">Overflow Operators</span></a>.</p>
<p>Swift also provides range operators that aren&rsquo;t found in C, such as <code class="docutils literal"><span class="pre">a..&lt;b</span></code> and <code class="docutils literal"><span class="pre">a...b</span></code>, as a shortcut for expressing a range of values.</p>
<p>This chapter describes the common operators in Swift. <a class="reference internal" href="AdvancedOperators.html"><span class="doc">Advanced Operators</span></a> covers Swift&rsquo;s advanced operators, and describes how to define your own custom operators and implement the standard operators for your own custom types.</p>
<div class="section" id="ID61">
<a class="dashingAutolink" name="autolink-36"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Terminology"></a><h2>Terminology<a class="headerlink" href="BasicOperators.html#ID61" title="Permalink to this headline"></a></h2>
<p>Operators are unary, binary, or ternary:</p>
<ul class="simple">
<li><em>Unary</em> operators operate on a single target (such as <code class="docutils literal"><span class="pre">-a</span></code>). Unary <em>prefix</em> operators appear immediately before their target (such as <code class="docutils literal"><span class="pre">!b</span></code>), and unary <em>postfix</em> operators appear immediately after their target (such as <code class="docutils literal"><span class="pre">c!</span></code>).</li>
<li><em>Binary</em> operators operate on two targets (such as <code class="docutils literal"><span class="pre">2</span> <span class="pre">+</span> <span class="pre">3</span></code>) and are <em>infix</em> because they appear in between their two targets.</li>
<li><em>Ternary</em> operators operate on three targets. Like C, Swift has only one ternary operator, the ternary conditional operator (<code class="docutils literal"><span class="pre">a</span> <span class="pre">?</span> <span class="pre">b</span> <span class="pre">:</span> <span class="pre">c</span></code>).</li>
</ul>
<p>The values that operators affect are <em>operands</em>. In the expression <code class="docutils literal"><span class="pre">1</span> <span class="pre">+</span> <span class="pre">2</span></code>, the <code class="docutils literal"><span class="pre">+</span></code> symbol is a binary operator and its two operands are the values <code class="docutils literal"><span class="pre">1</span></code> and <code class="docutils literal"><span class="pre">2</span></code>.</p>
</div>
<div class="section" id="ID62">
<a class="dashingAutolink" name="autolink-37"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Assignment%20Operator"></a><h2>Assignment Operator<a class="headerlink" href="BasicOperators.html#ID62" title="Permalink to this headline"></a></h2>
<p>The <em>assignment operator</em> (<code class="docutils literal"><span class="pre">a</span> <span class="pre">=</span> <span class="pre">b</span></code>) initializes or updates the value of <code class="docutils literal"><span class="pre">a</span></code> with the value of <code class="docutils literal"><span class="pre">b</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">b</span> = <span class="m">10</span>
</li><li><span class="k">var</span> <span class="nv">a</span> = <span class="m">5</span>
</li><li><span class="nv">a</span> = <span class="nv">b</span>
</li><li><span class="c">// a is now equal to 10</span>
</li></ol></pre></div></div>
<p>If the right side of the assignment is a tuple with multiple values, its elements can be decomposed into multiple constants or variables at once:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> (<span class="nv">x</span>, <span class="nv">y</span>) = (<span class="m">1</span>, <span class="m">2</span>)
</li><li><span class="c">// x is equal to 1, and y is equal to 2</span>
</li></ol></pre></div></div>
<p>Unlike the assignment operator in C and Objective-C, the assignment operator in Swift does not itself return a value. The following statement is not valid:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="nv">x</span> = <span class="nv">y</span> {
</li><li>    <span class="c">// This is not valid, because x = y does not return a value.</span>
</li><li>}
</li></ol></pre></div></div>
<p>This feature prevents the assignment operator (<code class="docutils literal"><span class="pre">=</span></code>) from being used by accident when the equal to operator (<code class="docutils literal"><span class="pre">==</span></code>) is actually intended. By making <code class="docutils literal"><span class="pre">if</span> <span class="pre">x</span> <span class="pre">=</span> <span class="pre">y</span></code> invalid, Swift helps you to avoid these kinds of errors in your code.</p>
</div>
<div class="section" id="ID63">
<a class="dashingAutolink" name="autolink-38"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Arithmetic%20Operators"></a><h2>Arithmetic Operators<a class="headerlink" href="BasicOperators.html#ID63" title="Permalink to this headline"></a></h2>
<p>Swift supports the four standard <em>arithmetic operators</em> for all number types:</p>
<ul class="simple">
<li>Addition (<code class="docutils literal"><span class="pre">+</span></code>)</li>
<li>Subtraction (<code class="docutils literal"><span class="pre">-</span></code>)</li>
<li>Multiplication (<code class="docutils literal"><span class="pre">*</span></code>)</li>
<li>Division (<code class="docutils literal"><span class="pre">/</span></code>)</li>
</ul>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">1</span> + <span class="m">2</span>       <span class="c">// equals 3</span>
</li><li><span class="m">5</span> - <span class="m">3</span>       <span class="c">// equals 2</span>
</li><li><span class="m">2</span> * <span class="m">3</span>       <span class="c">// equals 6</span>
</li><li><span class="m">10.0</span> / <span class="m">2.5</span>  <span class="c">// equals 4.0</span>
</li></ol></pre></div></div>
<p>Unlike the arithmetic operators in C and Objective-C, the Swift arithmetic operators don&rsquo;t allow values to overflow by default. You can opt in to value overflow behavior by using Swift&rsquo;s overflow operators (such as <code class="docutils literal"><span class="pre">a</span> <span class="pre">&amp;+</span> <span class="pre">b</span></code>). See <a class="reference internal" href="AdvancedOperators.html#ID37"><span class="std std-ref">Overflow Operators</span></a>.</p>
<p>The addition operator is also supported for <code class="docutils literal"><span class="pre">String</span></code> concatenation:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="s">&#34;hello, &#34;</span> + <span class="s">&#34;world&#34;</span>  <span class="c">// equals &#34;hello, world&#34;</span>
</li></ol></pre></div></div>
<div class="section" id="ID64">
<h3>Remainder Operator<a class="headerlink" href="BasicOperators.html#ID64" title="Permalink to this headline"></a></h3>
<p>The <em>remainder operator</em> (<code class="docutils literal"><span class="pre">a</span> <span class="pre">%</span> <span class="pre">b</span></code>) works out how many multiples of <code class="docutils literal"><span class="pre">b</span></code> will fit inside <code class="docutils literal"><span class="pre">a</span></code> and returns the value that is left over (known as the <em>remainder</em>).</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The remainder operator (<code class="docutils literal"><span class="pre">%</span></code>) is also known as a <em>modulo operator</em> in other languages. However, its behavior in Swift for negative numbers means that, strictly speaking, it&rsquo;s a remainder rather than a modulo operation.</p>
</div>
<p>Here&rsquo;s how the remainder operator works. To calculate <code class="docutils literal"><span class="pre">9</span> <span class="pre">%</span> <span class="pre">4</span></code>, you first work out how many <code class="docutils literal"><span class="pre">4</span></code>s will fit inside <code class="docutils literal"><span class="pre">9</span></code>:</p>
<img alt="../_images/remainderInteger_2x.png" class="align-center" src="../_images/remainderInteger_2x.png" style="width: 337px;"/>
<p>You can fit two <code class="docutils literal"><span class="pre">4</span></code>s inside <code class="docutils literal"><span class="pre">9</span></code>, and the remainder is <code class="docutils literal"><span class="pre">1</span></code> (shown in orange).</p>
<p>In Swift, this would be written as:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">9</span> % <span class="m">4</span>    <span class="c">// equals 1</span>
</li></ol></pre></div></div>
<p>To determine the answer for <code class="docutils literal"><span class="pre">a</span> <span class="pre">%</span> <span class="pre">b</span></code>, the <code class="docutils literal"><span class="pre">%</span></code> operator calculates the following equation and returns <code class="docutils literal"><span class="pre">remainder</span></code> as its output:</p>
<p><code class="docutils literal"><span class="pre">a</span></code> = (<code class="docutils literal"><span class="pre">b</span></code> x <code class="docutils literal"><span class="pre">some</span> <span class="pre">multiplier</span></code>) + <code class="docutils literal"><span class="pre">remainder</span></code></p>
<p>where <code class="docutils literal"><span class="pre">some</span> <span class="pre">multiplier</span></code> is the largest number of multiples of <code class="docutils literal"><span class="pre">b</span></code> that will fit inside <code class="docutils literal"><span class="pre">a</span></code>.</p>
<p>Inserting <code class="docutils literal"><span class="pre">9</span></code> and <code class="docutils literal"><span class="pre">4</span></code> into this equation yields:</p>
<p><code class="docutils literal"><span class="pre">9</span></code> = (<code class="docutils literal"><span class="pre">4</span></code> x <code class="docutils literal"><span class="pre">2</span></code>) + <code class="docutils literal"><span class="pre">1</span></code></p>
<p>The same method is applied when calculating the remainder for a negative value of <code class="docutils literal"><span class="pre">a</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">-9</span> % <span class="m">4</span>   <span class="c">// equals -1</span>
</li></ol></pre></div></div>
<p>Inserting <code class="docutils literal"><span class="pre">-9</span></code> and <code class="docutils literal"><span class="pre">4</span></code> into the equation yields:</p>
<p><code class="docutils literal"><span class="pre">-9</span></code> = (<code class="docutils literal"><span class="pre">4</span></code> x <code class="docutils literal"><span class="pre">-2</span></code>) + <code class="docutils literal"><span class="pre">-1</span></code></p>
<p>giving a remainder value of <code class="docutils literal"><span class="pre">-1</span></code>.</p>
<p>The sign of <code class="docutils literal"><span class="pre">b</span></code> is ignored for negative values of <code class="docutils literal"><span class="pre">b</span></code>. This means that <code class="docutils literal"><span class="pre">a</span> <span class="pre">%</span> <span class="pre">b</span></code> and <code class="docutils literal"><span class="pre">a</span> <span class="pre">%</span> <span class="pre">-b</span></code> always give the same answer.</p>
</div>
<div class="section" id="ID67">
<h3>Unary Minus Operator<a class="headerlink" href="BasicOperators.html#ID67" title="Permalink to this headline"></a></h3>
<p>The sign of a numeric value can be toggled using a prefixed <code class="docutils literal"><span class="pre">-</span></code>, known as the <em>unary minus operator</em>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">three</span> = <span class="m">3</span>
</li><li><span class="k">let</span> <span class="nv">minusThree</span> = -<span class="nv">three</span>       <span class="c">// minusThree equals -3</span>
</li><li><span class="k">let</span> <span class="nv">plusThree</span> = -<span class="nv">minusThree</span>   <span class="c">// plusThree equals 3, or &#34;minus minus three&#34;</span>
</li></ol></pre></div></div>
<p>The unary minus operator (<code class="docutils literal"><span class="pre">-</span></code>) is prepended directly before the value it operates on, without any white space.</p>
</div>
<div class="section" id="ID68">
<h3>Unary Plus Operator<a class="headerlink" href="BasicOperators.html#ID68" title="Permalink to this headline"></a></h3>
<p>The <em>unary plus operator</em> (<code class="docutils literal"><span class="pre">+</span></code>) simply returns the value it operates on, without any change:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">minusSix</span> = <span class="m">-6</span>
</li><li><span class="k">let</span> <span class="nv">alsoMinusSix</span> = +<span class="nv">minusSix</span>  <span class="c">// alsoMinusSix equals -6</span>
</li></ol></pre></div></div>
<p>Although the unary plus operator doesn&rsquo;t actually do anything, you can use it to provide symmetry in your code for positive numbers when also using the unary minus operator for negative numbers.</p>
</div>
</div>
<div class="section" id="ID69">
<a class="dashingAutolink" name="autolink-39"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Compound%20Assignment%20Operators"></a><h2>Compound Assignment Operators<a class="headerlink" href="BasicOperators.html#ID69" title="Permalink to this headline"></a></h2>
<p>Like C, Swift provides <em>compound assignment operators</em> that combine assignment (<code class="docutils literal"><span class="pre">=</span></code>) with another operation. One example is the <em>addition assignment operator</em> (<code class="docutils literal"><span class="pre">+=</span></code>):</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">a</span> = <span class="m">1</span>
</li><li><span class="nv">a</span> += <span class="m">2</span>
</li><li><span class="c">// a is now equal to 3</span>
</li></ol></pre></div></div>
<p>The expression <code class="docutils literal"><span class="pre">a</span> <span class="pre">+=</span> <span class="pre">2</span></code> is shorthand for <code class="docutils literal"><span class="pre">a</span> <span class="pre">=</span> <span class="pre">a</span> <span class="pre">+</span> <span class="pre">2</span></code>. Effectively, the addition and the assignment are combined into one operator that performs both tasks at the same time.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The compound assignment operators don&rsquo;t return a value. For example, you can&rsquo;t write <code class="docutils literal"><span class="pre">let</span> <span class="pre">b</span> <span class="pre">=</span> <span class="pre">a</span> <span class="pre">+=</span> <span class="pre">2</span></code>.</p>
</div>
<p>For information about the operators provided by the Swift standard library, see <a class="reference external" href="https://developer.apple.com/documentation/swift/operator_declarations">Operator Declarations</a>.</p>
</div>
<div class="section" id="ID70">
<a class="dashingAutolink" name="autolink-40"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Comparison%20Operators"></a><h2>Comparison Operators<a class="headerlink" href="BasicOperators.html#ID70" title="Permalink to this headline"></a></h2>
<p>Swift supports all standard C <em>comparison operators</em>:</p>
<ul class="simple">
<li>Equal to (<code class="docutils literal"><span class="pre">a</span> <span class="pre">==</span> <span class="pre">b</span></code>)</li>
<li>Not equal to (<code class="docutils literal"><span class="pre">a</span> <span class="pre">!=</span> <span class="pre">b</span></code>)</li>
<li>Greater than (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&gt;</span> <span class="pre">b</span></code>)</li>
<li>Less than (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&lt;</span> <span class="pre">b</span></code>)</li>
<li>Greater than or equal to (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&gt;=</span> <span class="pre">b</span></code>)</li>
<li>Less than or equal to (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&lt;=</span> <span class="pre">b</span></code>)</li>
</ul>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Swift also provides two <em>identity operators</em> (<code class="docutils literal"><span class="pre">===</span></code> and <code class="docutils literal"><span class="pre">!==</span></code>), which you use to test whether two object references both refer to the same object instance. For more information, see <a class="reference internal" href="ClassesAndStructures.html"><span class="doc">Structures and Classes</span></a>.</p>
</div>
<p>Each of the comparison operators returns a <code class="docutils literal"><span class="pre">Bool</span></code> value to indicate whether or not the statement is true:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">1</span> == <span class="m">1</span>   <span class="c">// true because 1 is equal to 1</span>
</li><li><span class="m">2</span> != <span class="m">1</span>   <span class="c">// true because 2 is not equal to 1</span>
</li><li><span class="m">2</span> &gt; <span class="m">1</span>    <span class="c">// true because 2 is greater than 1</span>
</li><li><span class="m">1</span> &lt; <span class="m">2</span>    <span class="c">// true because 1 is less than 2</span>
</li><li><span class="m">1</span> &gt;= <span class="m">1</span>   <span class="c">// true because 1 is greater than or equal to 1</span>
</li><li><span class="m">2</span> &lt;= <span class="m">1</span>   <span class="c">// false because 2 is not less than or equal to 1</span>
</li></ol></pre></div></div>
<p>Comparison operators are often used in conditional statements, such as the <code class="docutils literal"><span class="pre">if</span></code> statement:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">name</span> = <span class="s">&#34;world&#34;</span>
</li><li><span class="k">if</span> <span class="nv">name</span> == <span class="s">&#34;world&#34;</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;hello, world&#34;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;I&#39;m sorry </span>\<span class="p">(</span><span class="nv">name</span><span class="p">)</span><span class="s">, but I don&#39;t recognize you&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;hello, world&#34;, because name is indeed equal to &#34;world&#34;.</span>
</li></ol></pre></div></div>
<p>For more about the <code class="docutils literal"><span class="pre">if</span></code> statement, see <a class="reference internal" href="ControlFlow.html"><span class="doc">Control Flow</span></a>.</p>
<p>You can compare two tuples if they have the same type and the same number of values. Tuples are compared from left to right, one value at a time, until the comparison finds two values that aren&rsquo;t equal. Those two values are compared, and the result of that comparison determines the overall result of the tuple comparison. If all the elements are equal, then the tuples themselves are equal. For example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li>(<span class="m">1</span>, <span class="s">&#34;zebra&#34;</span>) &lt; (<span class="m">2</span>, <span class="s">&#34;apple&#34;</span>)   <span class="c">// true because 1 is less than 2; &#34;zebra&#34; and &#34;apple&#34; are not compared</span>
</li><li>(<span class="m">3</span>, <span class="s">&#34;apple&#34;</span>) &lt; (<span class="m">3</span>, <span class="s">&#34;bird&#34;</span>)    <span class="c">// true because 3 is equal to 3, and &#34;apple&#34; is less than &#34;bird&#34;</span>
</li><li>(<span class="m">4</span>, <span class="s">&#34;dog&#34;</span>) == (<span class="m">4</span>, <span class="s">&#34;dog&#34;</span>)      <span class="c">// true because 4 is equal to 4, and &#34;dog&#34; is equal to &#34;dog&#34;</span>
</li></ol></pre></div></div>
<p>In the example above, you can see the left-to-right comparison behavior on the first line. Because <code class="docutils literal"><span class="pre">1</span></code> is less than <code class="docutils literal"><span class="pre">2</span></code>, <code class="docutils literal"><span class="pre">(1,</span> <span class="pre">&#34;zebra&#34;)</span></code> is considered less than <code class="docutils literal"><span class="pre">(2,</span> <span class="pre">&#34;apple&#34;)</span></code>, regardless of any other values in the tuples. It doesn&rsquo;t matter that <code class="docutils literal"><span class="pre">&#34;zebra&#34;</span></code> isn&rsquo;t less than <code class="docutils literal"><span class="pre">&#34;apple&#34;</span></code>, because the comparison is already determined by the tuples&rsquo; first elements. However, when the tuples&rsquo; first elements are the same, their second elements <em>are</em> compared&mdash;this is what happens on the second and third line.</p>
<p>Tuples can be compared with a given operator only if the operator can be applied to each value in the respective tuples. For example, as demonstrated in the code below, you can compare two tuples of type <code class="docutils literal"><span class="pre">(String,</span> <span class="pre">Int)</span></code> because both <code class="docutils literal"><span class="pre">String</span></code> and <code class="docutils literal"><span class="pre">Int</span></code> values can be compared using the <code class="docutils literal"><span class="pre">&lt;</span></code> operator. In contrast, two tuples of type <code class="docutils literal"><span class="pre">(String,</span> <span class="pre">Bool)</span></code> can&rsquo;t be compared with the <code class="docutils literal"><span class="pre">&lt;</span></code> operator because the <code class="docutils literal"><span class="pre">&lt;</span></code> operator can&rsquo;t be applied to <code class="docutils literal"><span class="pre">Bool</span></code> values.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li>(<span class="s">&#34;blue&#34;</span>, <span class="m">-1</span>) &lt; (<span class="s">&#34;purple&#34;</span>, <span class="m">1</span>)        <span class="c">// OK, evaluates to true</span>
</li><li>(<span class="s">&#34;blue&#34;</span>, <span class="k">false</span>) &lt; (<span class="s">&#34;purple&#34;</span>, <span class="k">true</span>)  <span class="c">// Error because &lt; can&#39;t compare Boolean values</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The Swift standard library includes tuple comparison operators for tuples with fewer than seven elements. To compare tuples with seven or more elements, you must implement the comparison operators yourself.</p>
</div>
</div>
<div class="section" id="ID71">
<a class="dashingAutolink" name="autolink-41"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Ternary%20Conditional%20Operator"></a><h2>Ternary Conditional Operator<a class="headerlink" href="BasicOperators.html#ID71" title="Permalink to this headline"></a></h2>
<p>The <em>ternary conditional operator</em> is a special operator with three parts, which takes the form <code class="docutils literal"><span class="pre">question</span> <span class="pre">?</span> <span class="pre">answer1</span> <span class="pre">:</span> <span class="pre">answer2</span></code>. It&rsquo;s a shortcut for evaluating one of two expressions based on whether <code class="docutils literal"><span class="pre">question</span></code> is true or false. If <code class="docutils literal"><span class="pre">question</span></code> is true, it evaluates <code class="docutils literal"><span class="pre">answer1</span></code> and returns its value; otherwise, it evaluates <code class="docutils literal"><span class="pre">answer2</span></code> and returns its value.</p>
<p>The ternary conditional operator is shorthand for the code below:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="nv">question</span> {
</li><li>    <span class="nv">answer1</span>
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">answer2</span>
</li><li>}
</li></ol></pre></div></div>
<p>Here&rsquo;s an example, which calculates the height for a table row. The row height should be 50 points taller than the content height if the row has a header, and 20 points taller if the row doesn&rsquo;t have a header:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">contentHeight</span> = <span class="m">40</span>
</li><li><span class="k">let</span> <span class="nv">hasHeader</span> = <span class="k">true</span>
</li><li><span class="k">let</span> <span class="nv">rowHeight</span> = <span class="nv">contentHeight</span> + (<span class="nv">hasHeader</span> ? <span class="m">50</span> : <span class="m">20</span>)
</li><li><span class="c">// rowHeight is equal to 90</span>
</li></ol></pre></div></div>
<p>The example above is shorthand for the code below:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">contentHeight</span> = <span class="m">40</span>
</li><li><span class="k">let</span> <span class="nv">hasHeader</span> = <span class="k">true</span>
</li><li><span class="k">let</span> <span class="nv">rowHeight</span>: <span class="nc">Int</span>
</li><li><span class="k">if</span> <span class="nv">hasHeader</span> {
</li><li>    <span class="nv">rowHeight</span> = <span class="nv">contentHeight</span> + <span class="m">50</span>
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">rowHeight</span> = <span class="nv">contentHeight</span> + <span class="m">20</span>
</li><li>}
</li><li><span class="c">// rowHeight is equal to 90</span>
</li></ol></pre></div></div>
<p>The first example&rsquo;s use of the ternary conditional operator means that <code class="docutils literal"><span class="pre">rowHeight</span></code> can be set to the correct value on a single line of code, which is more concise than the code used in the second example.</p>
<p>The ternary conditional operator provides an efficient shorthand for deciding which of two expressions to consider. Use the ternary conditional operator with care, however. Its conciseness can lead to hard-to-read code if overused. Avoid combining multiple instances of the ternary conditional operator into one compound statement.</p>
</div>
<div class="section" id="ID72">
<a class="dashingAutolink" name="autolink-42"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Nil-Coalescing%20Operator"></a><h2>Nil-Coalescing Operator<a class="headerlink" href="BasicOperators.html#ID72" title="Permalink to this headline"></a></h2>
<p>The <em>nil-coalescing operator</em> (<code class="docutils literal"><span class="pre">a</span> <span class="pre">??</span> <span class="pre">b</span></code>) unwraps an optional <code class="docutils literal"><span class="pre">a</span></code> if it contains a value, or returns a default value <code class="docutils literal"><span class="pre">b</span></code> if <code class="docutils literal"><span class="pre">a</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>. The expression <code class="docutils literal"><span class="pre">a</span></code> is always of an optional type. The expression <code class="docutils literal"><span class="pre">b</span></code> must match the type that is stored inside <code class="docutils literal"><span class="pre">a</span></code>.</p>
<p>The nil-coalescing operator is shorthand for the code below:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">a</span> != <span class="k">nil</span> ? <span class="nv">a</span>! : <span class="nv">b</span>
</li></ol></pre></div></div>
<p>The code above uses the ternary conditional operator and forced unwrapping (<code class="docutils literal"><span class="pre">a!</span></code>) to access the value wrapped inside <code class="docutils literal"><span class="pre">a</span></code> when <code class="docutils literal"><span class="pre">a</span></code> is not <code class="docutils literal"><span class="pre">nil</span></code>, and to return <code class="docutils literal"><span class="pre">b</span></code> otherwise. The nil-coalescing operator provides a more elegant way to encapsulate this conditional checking and unwrapping in a concise and readable form.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If the value of <code class="docutils literal"><span class="pre">a</span></code> is non-<code class="docutils literal"><span class="pre">nil</span></code>, the value of <code class="docutils literal"><span class="pre">b</span></code> is not evaluated. This is known as <em>short-circuit evaluation</em>.</p>
</div>
<p>The example below uses the nil-coalescing operator to choose between a default color name and an optional user-defined color name:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">defaultColorName</span> = <span class="s">&#34;red&#34;</span>
</li><li><span class="k">var</span> <span class="nv">userDefinedColorName</span>: <span class="nc">String</span>?   <span class="c">// defaults to nil</span>
</li><li>
</li><li><span class="k">var</span> <span class="nv">colorNameToUse</span> = <span class="nv">userDefinedColorName</span> ?? <span class="nv">defaultColorName</span>
</li><li><span class="c">// userDefinedColorName is nil, so colorNameToUse is set to the default of &#34;red&#34;</span>
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">userDefinedColorName</span></code> variable is defined as an optional <code class="docutils literal"><span class="pre">String</span></code>, with a default value of <code class="docutils literal"><span class="pre">nil</span></code>. Because <code class="docutils literal"><span class="pre">userDefinedColorName</span></code> is of an optional type, you can use the nil-coalescing operator to consider its value. In the example above, the operator is used to determine an initial value for a <code class="docutils literal"><span class="pre">String</span></code> variable called <code class="docutils literal"><span class="pre">colorNameToUse</span></code>. Because <code class="docutils literal"><span class="pre">userDefinedColorName</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>, the expression <code class="docutils literal"><span class="pre">userDefinedColorName</span> <span class="pre">??</span> <span class="pre">defaultColorName</span></code> returns the value of <code class="docutils literal"><span class="pre">defaultColorName</span></code>, or <code class="docutils literal"><span class="pre">&#34;red&#34;</span></code>.</p>
<p>If you assign a non-<code class="docutils literal"><span class="pre">nil</span></code> value to <code class="docutils literal"><span class="pre">userDefinedColorName</span></code> and perform the nil-coalescing operator check again, the value wrapped inside <code class="docutils literal"><span class="pre">userDefinedColorName</span></code> is used instead of the default:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">userDefinedColorName</span> = <span class="s">&#34;green&#34;</span>
</li><li><span class="nv">colorNameToUse</span> = <span class="nv">userDefinedColorName</span> ?? <span class="nv">defaultColorName</span>
</li><li><span class="c">// userDefinedColorName is not nil, so colorNameToUse is set to &#34;green&#34;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID73">
<a class="dashingAutolink" name="autolink-43"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Range%20Operators"></a><h2>Range Operators<a class="headerlink" href="BasicOperators.html#ID73" title="Permalink to this headline"></a></h2>
<p>Swift includes several <em>range operators</em>, which are shortcuts for expressing a range of values.</p>
<div class="section" id="ID74">
<h3>Closed Range Operator<a class="headerlink" href="BasicOperators.html#ID74" title="Permalink to this headline"></a></h3>
<p>The <em>closed range operator</em> (<code class="docutils literal"><span class="pre">a...b</span></code>) defines a range that runs from <code class="docutils literal"><span class="pre">a</span></code> to <code class="docutils literal"><span class="pre">b</span></code>, and includes the values <code class="docutils literal"><span class="pre">a</span></code> and <code class="docutils literal"><span class="pre">b</span></code>. The value of <code class="docutils literal"><span class="pre">a</span></code> must not be greater than <code class="docutils literal"><span class="pre">b</span></code>.</p>
<p>The closed range operator is useful when iterating over a range in which you want all of the values to be used, such as with a <code class="docutils literal"><span class="pre">for</span></code>-<code class="docutils literal"><span class="pre">in</span></code> loop:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">for</span> <span class="nv">index</span> <span class="k">in</span> <span class="m">1</span>...<span class="m">5</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;</span>\<span class="p">(</span><span class="nv">index</span><span class="p">)</span><span class="s"> times 5 is </span>\<span class="p">(</span><span class="nv">index</span> * <span class="m">5</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>}
</li><li><span class="c">// 1 times 5 is 5</span>
</li><li><span class="c">// 2 times 5 is 10</span>
</li><li><span class="c">// 3 times 5 is 15</span>
</li><li><span class="c">// 4 times 5 is 20</span>
</li><li><span class="c">// 5 times 5 is 25</span>
</li></ol></pre></div></div>
<p>For more about <code class="docutils literal"><span class="pre">for</span></code>-<code class="docutils literal"><span class="pre">in</span></code> loops, see <a class="reference internal" href="ControlFlow.html"><span class="doc">Control Flow</span></a>.</p>
</div>
<div class="section" id="ID75">
<h3>Half-Open Range Operator<a class="headerlink" href="BasicOperators.html#ID75" title="Permalink to this headline"></a></h3>
<p>The <em>half-open range operator</em> (<code class="docutils literal"><span class="pre">a..&lt;b</span></code>) defines a range that runs from <code class="docutils literal"><span class="pre">a</span></code> to <code class="docutils literal"><span class="pre">b</span></code>, but doesn&rsquo;t include <code class="docutils literal"><span class="pre">b</span></code>. It&rsquo;s said to be <em>half-open</em> because it contains its first value, but not its final value. As with the closed range operator, the value of <code class="docutils literal"><span class="pre">a</span></code> must not be greater than <code class="docutils literal"><span class="pre">b</span></code>. If the value of <code class="docutils literal"><span class="pre">a</span></code> is equal to <code class="docutils literal"><span class="pre">b</span></code>, then the resulting range will be empty.</p>
<p>Half-open ranges are particularly useful when you work with zero-based lists such as arrays, where it&rsquo;s useful to count up to (but not including) the length of the list:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">names</span> = [<span class="s">&#34;Anna&#34;</span>, <span class="s">&#34;Alex&#34;</span>, <span class="s">&#34;Brian&#34;</span>, <span class="s">&#34;Jack&#34;</span>]
</li><li><span class="k">let</span> <span class="nv">count</span> = <span class="nv">names</span>.<span class="nv">count</span>
</li><li><span class="k">for</span> <span class="nv">i</span> <span class="k">in</span> <span class="m">0</span>..&lt;<span class="nv">count</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Person </span>\<span class="p">(</span><span class="nv">i</span> + <span class="m">1</span><span class="p">)</span><span class="s"> is called </span>\<span class="p">(</span><span class="nv">names</span>[<span class="nv">i</span>]<span class="p">)</span><span class="s">&#34;</span>)
</li><li>}
</li><li><span class="c">// Person 1 is called Anna</span>
</li><li><span class="c">// Person 2 is called Alex</span>
</li><li><span class="c">// Person 3 is called Brian</span>
</li><li><span class="c">// Person 4 is called Jack</span>
</li></ol></pre></div></div>
<p>Note that the array contains four items, but <code class="docutils literal"><span class="pre">0..&lt;count</span></code> only counts as far as <code class="docutils literal"><span class="pre">3</span></code> (the index of the last item in the array), because it&rsquo;s a half-open range. For more about arrays, see <a class="reference internal" href="CollectionTypes.html#ID107"><span class="std std-ref">Arrays</span></a>.</p>
</div>
<div class="section" id="ID562">
<h3>One-Sided Ranges<a class="headerlink" href="BasicOperators.html#ID562" title="Permalink to this headline"></a></h3>
<p>The closed range operator has an alternative form for ranges that continue as far as possible in one direction&mdash;for example, a range that includes all the elements of an array from index 2 to the end of the array. In these cases, you can omit the value from one side of the range operator. This kind of range is called a <em>one-sided range</em> because the operator has a value on only one side. For example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">for</span> <span class="nv">name</span> <span class="k">in</span> <span class="nv">names</span>[<span class="m">2</span>...] {
</li><li>    <span class="nv">print</span>(<span class="nv">name</span>)
</li><li>}
</li><li><span class="c">// Brian</span>
</li><li><span class="c">// Jack</span>
</li><li>
</li><li><span class="k">for</span> <span class="nv">name</span> <span class="k">in</span> <span class="nv">names</span>[...<span class="m">2</span>] {
</li><li>    <span class="nv">print</span>(<span class="nv">name</span>)
</li><li>}
</li><li><span class="c">// Anna</span>
</li><li><span class="c">// Alex</span>
</li><li><span class="c">// Brian</span>
</li></ol></pre></div></div>
<p>The half-open range operator also has a one-sided form that&rsquo;s written with only its final value. Just like when you include a value on both sides, the final value isn&rsquo;t part of the range. For example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">for</span> <span class="nv">name</span> <span class="k">in</span> <span class="nv">names</span>[..&lt;<span class="m">2</span>] {
</li><li>    <span class="nv">print</span>(<span class="nv">name</span>)
</li><li>}
</li><li><span class="c">// Anna</span>
</li><li><span class="c">// Alex</span>
</li></ol></pre></div></div>
<p>One-sided ranges can be used in other contexts, not just in subscripts. You can&rsquo;t iterate over a one-sided range that omits a first value, because it isn&rsquo;t clear where iteration should begin. You <em>can</em> iterate over a one-sided range that omits its final value; however, because the range continues indefinitely, make sure you add an explicit end condition for the loop. You can also check whether a one-sided range contains a particular value, as shown in the code below.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">range</span> = ...<span class="m">5</span>
</li><li><span class="nv">range</span>.<span class="nv">contains</span>(<span class="m">7</span>)   <span class="c">// false</span>
</li><li><span class="nv">range</span>.<span class="nv">contains</span>(<span class="m">4</span>)   <span class="c">// true</span>
</li><li><span class="nv">range</span>.<span class="nv">contains</span>(<span class="m">-1</span>)  <span class="c">// true</span>
</li></ol></pre></div></div>
</div>
</div>
<div class="section" id="ID76">
<a class="dashingAutolink" name="autolink-44"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Logical%20Operators"></a><h2>Logical Operators<a class="headerlink" href="BasicOperators.html#ID76" title="Permalink to this headline"></a></h2>
<p><em>Logical operators</em> modify or combine the Boolean logic values <code class="docutils literal"><span class="pre">true</span></code> and <code class="docutils literal"><span class="pre">false</span></code>. Swift supports the three standard logical operators found in C-based languages:</p>
<ul class="simple">
<li>Logical NOT (<code class="docutils literal"><span class="pre">!a</span></code>)</li>
<li>Logical AND (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&amp;&amp;</span> <span class="pre">b</span></code>)</li>
<li>Logical OR (<code class="docutils literal"><span class="pre">a</span> <span class="pre">||</span> <span class="pre">b</span></code>)</li>
</ul>
<div class="section" id="ID77">
<h3>Logical NOT Operator<a class="headerlink" href="BasicOperators.html#ID77" title="Permalink to this headline"></a></h3>
<p>The <em>logical NOT operator</em> (<code class="docutils literal"><span class="pre">!a</span></code>) inverts a Boolean value so that <code class="docutils literal"><span class="pre">true</span></code> becomes <code class="docutils literal"><span class="pre">false</span></code>, and <code class="docutils literal"><span class="pre">false</span></code> becomes <code class="docutils literal"><span class="pre">true</span></code>.</p>
<p>The logical NOT operator is a prefix operator, and appears immediately before the value it operates on, without any white space. It can be read as &ldquo;not <code class="docutils literal"><span class="pre">a</span></code>&rdquo;, as seen in the following example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">allowedEntry</span> = <span class="k">false</span>
</li><li><span class="k">if</span> !<span class="nv">allowedEntry</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;ACCESS DENIED&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;ACCESS DENIED&#34;</span>
</li></ol></pre></div></div>
<p>The phrase <code class="docutils literal"><span class="pre">if</span> <span class="pre">!allowedEntry</span></code> can be read as &ldquo;if not allowed entry.&rdquo; The subsequent line is only executed if &ldquo;not allowed entry&rdquo; is true; that is, if <code class="docutils literal"><span class="pre">allowedEntry</span></code> is <code class="docutils literal"><span class="pre">false</span></code>.</p>
<p>As in this example, careful choice of Boolean constant and variable names can help to keep code readable and concise, while avoiding double negatives or confusing logic statements.</p>
</div>
<div class="section" id="ID78">
<h3>Logical AND Operator<a class="headerlink" href="BasicOperators.html#ID78" title="Permalink to this headline"></a></h3>
<p>The <em>logical AND operator</em> (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&amp;&amp;</span> <span class="pre">b</span></code>) creates logical expressions where both values must be <code class="docutils literal"><span class="pre">true</span></code> for the overall expression to also be <code class="docutils literal"><span class="pre">true</span></code>.</p>
<p>If either value is <code class="docutils literal"><span class="pre">false</span></code>, the overall expression will also be <code class="docutils literal"><span class="pre">false</span></code>. In fact, if the <em>first</em> value is <code class="docutils literal"><span class="pre">false</span></code>, the second value won&rsquo;t even be evaluated, because it can&rsquo;t possibly make the overall expression equate to <code class="docutils literal"><span class="pre">true</span></code>. This is known as <em>short-circuit evaluation</em>.</p>
<p>This example considers two <code class="docutils literal"><span class="pre">Bool</span></code> values and only allows access if both values are <code class="docutils literal"><span class="pre">true</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">enteredDoorCode</span> = <span class="k">true</span>
</li><li><span class="k">let</span> <span class="nv">passedRetinaScan</span> = <span class="k">false</span>
</li><li><span class="k">if</span> <span class="nv">enteredDoorCode</span> &amp;&amp; <span class="nv">passedRetinaScan</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Welcome!&#34;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;ACCESS DENIED&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;ACCESS DENIED&#34;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID79">
<h3>Logical OR Operator<a class="headerlink" href="BasicOperators.html#ID79" title="Permalink to this headline"></a></h3>
<p>The <em>logical OR operator</em> (<code class="docutils literal"><span class="pre">a</span> <span class="pre">||</span> <span class="pre">b</span></code>) is an infix operator made from two adjacent pipe characters. You use it to create logical expressions in which only <em>one</em> of the two values has to be <code class="docutils literal"><span class="pre">true</span></code> for the overall expression to be <code class="docutils literal"><span class="pre">true</span></code>.</p>
<p>Like the Logical AND operator above, the Logical OR operator uses short-circuit evaluation to consider its expressions. If the left side of a Logical OR expression is <code class="docutils literal"><span class="pre">true</span></code>, the right side is not evaluated, because it can&rsquo;t change the outcome of the overall expression.</p>
<p>In the example below, the first <code class="docutils literal"><span class="pre">Bool</span></code> value (<code class="docutils literal"><span class="pre">hasDoorKey</span></code>) is <code class="docutils literal"><span class="pre">false</span></code>, but the second value (<code class="docutils literal"><span class="pre">knowsOverridePassword</span></code>) is <code class="docutils literal"><span class="pre">true</span></code>. Because one value is <code class="docutils literal"><span class="pre">true</span></code>, the overall expression also evaluates to <code class="docutils literal"><span class="pre">true</span></code>, and access is allowed:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">hasDoorKey</span> = <span class="k">false</span>
</li><li><span class="k">let</span> <span class="nv">knowsOverridePassword</span> = <span class="k">true</span>
</li><li><span class="k">if</span> <span class="nv">hasDoorKey</span> || <span class="nv">knowsOverridePassword</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Welcome!&#34;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;ACCESS DENIED&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;Welcome!&#34;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID80">
<h3>Combining Logical Operators<a class="headerlink" href="BasicOperators.html#ID80" title="Permalink to this headline"></a></h3>
<p>You can combine multiple logical operators to create longer compound expressions:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="nv">enteredDoorCode</span> &amp;&amp; <span class="nv">passedRetinaScan</span> || <span class="nv">hasDoorKey</span> || <span class="nv">knowsOverridePassword</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Welcome!&#34;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;ACCESS DENIED&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;Welcome!&#34;</span>
</li></ol></pre></div></div>
<p>This example uses multiple <code class="docutils literal"><span class="pre">&amp;&amp;</span></code> and <code class="docutils literal"><span class="pre">||</span></code> operators to create a longer compound expression. However, the <code class="docutils literal"><span class="pre">&amp;&amp;</span></code> and <code class="docutils literal"><span class="pre">||</span></code> operators still operate on only two values, so this is actually three smaller expressions chained together. The example can be read as:</p>
<p>If we&rsquo;ve entered the correct door code and passed the retina scan, or if we have a valid door key, or if we know the emergency override password, then allow access.</p>
<p>Based on the values of <code class="docutils literal"><span class="pre">enteredDoorCode</span></code>, <code class="docutils literal"><span class="pre">passedRetinaScan</span></code>, and <code class="docutils literal"><span class="pre">hasDoorKey</span></code>, the first two subexpressions are <code class="docutils literal"><span class="pre">false</span></code>. However, the emergency override password is known, so the overall compound expression still evaluates to <code class="docutils literal"><span class="pre">true</span></code>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The Swift logical operators <code class="docutils literal"><span class="pre">&amp;&amp;</span></code> and <code class="docutils literal"><span class="pre">||</span></code> are left-associative, meaning that compound expressions with multiple logical operators evaluate the leftmost subexpression first.</p>
</div>
</div>
<div class="section" id="ID81">
<h3>Explicit Parentheses<a class="headerlink" href="BasicOperators.html#ID81" title="Permalink to this headline"></a></h3>
<p>It&rsquo;s sometimes useful to include parentheses when they&rsquo;re not strictly needed, to make the intention of a complex expression easier to read. In the door access example above, it&rsquo;s useful to add parentheses around the first part of the compound expression to make its intent explicit:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> (<span class="nv">enteredDoorCode</span> &amp;&amp; <span class="nv">passedRetinaScan</span>) || <span class="nv">hasDoorKey</span> || <span class="nv">knowsOverridePassword</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Welcome!&#34;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;ACCESS DENIED&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;Welcome!&#34;</span>
</li></ol></pre></div></div>
<p>The parentheses make it clear that the first two values are considered as part of a separate possible state in the overall logic. The output of the compound expression doesn&rsquo;t change, but the overall intention is clearer to the reader. Readability is always preferred over brevity; use parentheses where they help to make your intentions clear.</p>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="TheBasics.html">The Basics</a></p>
        <p class="next"><a href="StringsAndCharacters.html">Strings and Characters</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>